package org.sadigit.control.errorhandlers;

// import java.util.LinkedHashMap;
import java.util.Map;
import java.util.LinkedHashMap;

import org.sadigit.control.exception.CustomException;

import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.core.Response.Status;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;

@Provider
public class CustomExceptionHandler implements ExceptionMapper<CustomException>{

    @Override
    public Response toResponse(CustomException exception) {

        if (exception.getCustomErrorStructure() != null) {
            return Response.status(Status.OK).entity(exception.getCustomErrorStructure()).build();
        } else {
            Map<String, Object> response = new LinkedHashMap<>();
            exception.printStackTrace();
            response.put("status", false);
            response.put("title", "Terjadi Kesalahan");
            response.put("message", exception.getMessage());
            return Response.status(Status.OK).entity(response).build();
        }
    }

}