package org.sadigit.control.errorhandlers;

import java.util.Map;

import org.sadigit.control.exception.GetDataGarduV2Exception;
import org.sadigit.model.response.base.ResponseModelGarduV2;

import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;

@Provider
public class GetDataGarduV2Handler implements ExceptionMapper<GetDataGarduV2Exception>{

    @Override
    public Response toResponse(GetDataGarduV2Exception exception) {
        
        ResponseModelGarduV2<Map<String,Object>> response = new ResponseModelGarduV2<>(); 
        response.setP_return(Map.of(
            "errorcode", exception.getErrorCode(),
            "info", exception.getMessage()
        ));

        return Response.status(Response.Status.OK).entity(response).build();
    }
    
}
