package org.sadigit.entity.masterYantek;

import jakarta.json.bind.annotation.JsonbTypeAdapter;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

import java.time.LocalDateTime;

import org.locationtech.jts.geom.Geometry;
import org.sadigit.adapter.GeometryAdapter;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;

@Entity
@Setter
@Getter
@Table(name = "regu_koordinat", schema = "apkt_transactional")
public class ReguKoordinat extends PanacheEntityBase {

    @Id
    @Column(name = "reguid", nullable = false)
    private Long reguid;

    @Column(name = "date_time")
    private LocalDateTime date_time;

    @Column(name = "user_id")
    private Long user_id;

    @Column(name = "unit_id")
    private Long unit_id;

    @Column(name = "user_name", length = 50)
    private String user_name;

    @Column(name = "regutype", length = 25)
    private String regutype;

    @JsonbTypeAdapter(GeometryAdapter.class)
    @Column(name = "geom_point", columnDefinition = "geometry(Point,4326)")
    private Geometry geom_point;

    @Column(name = "login_status", length = 10)
    private String login_status;

    @Column(name = "login_date")
    private LocalDateTime login_date;

    @Column(name = "jml_wo")
    private Long jml_wo;

    @Column(name = "lastupdate_wo")
    private LocalDateTime lastupdate_wo;

    @Column(name = "penugasan_khusus_laststatus", length = 50)
    private String penugasan_khusus_laststatus;

}