package org.sadigit.entity.referensi;

import lombok.Getter;
import lombok.Setter;

import java.sql.Timestamp;
import org.hibernate.annotations.Immutable;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import io.quarkus.runtime.annotations.RegisterForReflection;
import jakarta.persistence.*;

@Entity
@Getter
@Setter
@Immutable
@Table(name = "master_posko", schema = "apkt_transactional")
@RegisterForReflection
public class Posko extends PanacheEntity {

    @Column(name = "id")
    private Long id;

    @JoinColumn(name = "id_ulp", referencedColumnName = "id", nullable = false)
    @ManyToOne(fetch = FetchType.EAGER, optional = false, cascade = CascadeType.ALL)
    private Ulp ulp;

    @Column(name = "nama")
    private String nama;

    @Column(name = "created_date")
    private Timestamp createdDate;

    @Column(name = "created_by")
    private Long createdBy;

    @Column(name = "updated_date")
    private Timestamp updatedDate;

    @Column(name = "updated_by")
    private Long updatedBy;

    @Column(name = "kode")
    private String kode;

    @Column(name = "alamat")
    private String alamat;

    @Column(name = "city")
    private String city;

    @Column(name = "zip")
    private String zip;

    @Column(name = "telepon")
    private String telepon;

    @Column(name = "mobile")
    private String mobile;

    @Column(name = "fax")
    private String fax;

    @Column(name = "email")
    private String email;

    @Column(name = "ipaddress")
    private String ipAddress;

    @Column(name = "aktif", nullable = true)
    private Boolean aktif;

}
