package org.sadigit.entity.referensi;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "subissuetype", schema = "apkt_transactional")
public class SubTipeKeluhan extends PanacheEntityBase {
    @Id
    @Column(name = "subissuetypeid", nullable = false)
    private Long subissuetypeid;

    @JoinColumn(name = "issuetypeid", referencedColumnName = "issuetypeid", insertable = false, updatable = false)
    @ManyToOne(optional = false, fetch = FetchType.EAGER)
    private TipeKeluhan tipeKeluhan;
    
    @Column(name = "subissuetypename", length = 200)
    private String subissuetypename;

    @Column(name = "projectid")
    private Long projectid;

    @Column(name = "isactive", length = 1)
    private String isactive;

    @Column(name = "description", length = 4000)
    private String description;

}
