package org.sadigit.entity.referensi;

import java.util.List;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "issuetype", schema = "apkt_transactional")
public class TipeKeluhan extends PanacheEntityBase {
    @Id
    @Column(name = "issuetypeid", nullable = false)
    private Long issuetypeid;

    @Column(name = "issuetypecode", length = 10)
    private String issuetypecode;

    @Column(name = "issuetypename", length = 200)
    private String issuetypename;

    @Column(name = "projectid")
    private Long projectid;

    @Column(name = "isactive", length = 1)
    private String isactive;

    @Column(name = "description", length = 4000)
    private String description;

    @OneToMany(cascade = CascadeType.ALL, orphanRemoval = true)
    @JoinColumn(name = "issuetypeid")
    private List<SubTipeKeluhan> subTipeKeluhan;

}
