package org.sadigit.entity.referensi;

import java.time.LocalDate;
import java.util.List;

import org.hibernate.annotations.Immutable;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Immutable
@Table(name = "tipe_permasalahan", schema = "apkt_transactional")
public class TipePermasalahan extends PanacheEntity {

    @Column(name = "id")
    private Long id;

    @Column(name = "nama", nullable = false)
    private String nama;

    @OneToMany(cascade = CascadeType.ALL, orphanRemoval = true)
    @JoinColumn(name = "id_tipe_permasalahan")
    private List<SubTipePermasalahan> subTipePermasalahan;
    
    @Column(name = "created_date")
    private LocalDate created_date;

    @Column(name = "created_by")
    private Long created_by;

    @Column(name = "updated_date")
    private LocalDate updated_date;

    @Column(name = "updated_by")
    private Long updated_by;


}
