package org.sadigit.entity.referensi;

import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.time.Instant;
import org.hibernate.annotations.Immutable;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Getter
@Setter
@Immutable
@Table(name = "master_uid", schema = "apkt_transactional")
public class Uid extends PanacheEntity {

    @Column(name = "id")
    private Long id;

    @Column(name = "nama", nullable = false)
    private String nama;

    @Column(name = "kode", nullable = false)
    private String kode;

    // @Column(name = "location")
    // private String location;

    @Column(name = "created_date", nullable = false)
    private Instant createdDate;

    @Column(name = "created_by", nullable = false)
    private Long createdBy;

    @Column(name = "updated_date")
    private Instant updatedDate;

    @Column(name = "updated_by")
    private Long updatedBy;

    @Column(name = "alamat")
    private String alamat;

    @Column(name = "telepon")
    private String telepon;

    @Column(name = "aktif", nullable = false)
    private Boolean aktif;

    @Column(name = "unittypeid")
    private BigDecimal unittypeid;

    @Column(name = "unitparent")
    private BigDecimal unitparent;

    @Column(name = "city", length = 50)
    private String city;

    @Column(name = "zip", length = 5)
    private String zip;

    @Column(name = "mobile", length = 20)
    private String mobile;

    @Column(name = "fax", length = 20)
    private String fax;

    @Column(name = "email", length = 100)
    private String email;

    @Column(name = "ipaddress", length = 15)
    private String ipaddress;

    @Column(name = "coordinator")
    private BigDecimal coordinator;

    @Column(name = "supervisor")
    private BigDecimal supervisor;

    @Column(name = "assistantmanager")
    private BigDecimal assistantmanager;

    @Column(name = "assmanphone", length = 20)
    private String assmanphone;

    @Column(name = "vehiclecolor", length = 10)
    private String vehiclecolor;

    @Column(name = "id_pulau")
    private Long idPulau;

    // @Column(name = "geom_point")
    // private String geomPoint;
    @ManyToOne(fetch = FetchType.EAGER, optional = true, cascade = CascadeType.ALL)
    @JoinColumn(name = "id_regional", nullable = true)
    private Regional regional;

}
