package org.sadigit.entity.saidisaifi.masterJaringan;

import java.time.LocalDate;
import org.hibernate.annotations.Immutable;
import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import jakarta.persistence.Transient;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "ss_jaringan", schema = "apkt_transactional")
@Immutable
public class MasterJaringan extends PanacheEntityBase {
    
    @Id
    @Column(name = "kode_asset", length = 100, nullable = false)
    public String kodeAsset;

    @Column(name = "parent_asset", length = 100)
    public String parentAsset;

    @Column(name = "jenis_asset", length = 50)
    public String jenisAsset;

    @Column(name = "levelid")
    public Long levelId;

    @Column(name = "nama", length = 100)
    public String nama;

    @Column(name = "alamat", length = 200)
    public String alamat;

    @Column(name = "longitude", length = 50)
    public String longitude;

    @Column(name = "latitude", length = 50)
    public String latitude;

    @Column(name = "kva")
    public Long kva;

    @Column(name = "jml_plgn")
    public Long jmlPlgn;

    @Column(name = "asumsi")
    public Long asumsi;

    @Column(name = "status_nyala")
    public Long statusNyala;

    @Column(name = "phase")
    public Long phase;

    @Column(name = "beban_s", precision = 22, scale = 2)
    public Long bebanS;

    @Column(name = "beban_r", precision = 22, scale = 2)
    public Long bebanR;

    @Column(name = "beban_t", precision = 22, scale = 2)
    public Long bebanT;

    @Column(name = "beban_srt", precision = 22, scale = 2)
    public Long bebanSrt;

    @Column(name = "beban_x1", precision = 22, scale = 2)
    public Long bebanX1;

    @Column(name = "beban_x2", precision = 22, scale = 2)
    public Long bebanX2;

    @Column(name = "jurusan_beban", length = 5)
    public String jurusanBeban;

    @Column(name = "jenis_komponen", length = 50)
    public String jenisKomponen;

    @Column(name = "keterangan", length = 200)
    public String keterangan;

    @Column(name = "distribusi", length = 6)
    public String distribusi;

    @Column(name = "area", length = 6)
    public String area;

    @Column(name = "unit", length = 6)
    public String unit;

    @Column(name = "createdate")
    public LocalDate createDate;

    @Column(name = "createby", length = 50)
    public String createBy;

    @Column(name = "updatedate")
    public LocalDate updateDate;

    @Column(name = "updateby", length = 50)
    public String updateBy;

    @Column(name = "kode_gi", length = 10)
    public String kodeGi;

    @Column(name = "no_tiang", length = 400)
    public String noTiang;

    @Column(name = "kode_feeder", length = 400)
    public String kodeFeeder;

    @Column(name = "type_asset")
    public Long typeAsset;

    @Column(name = "kode_zone", length = 400)
    public String kodeZone;

    @Column(name = "kode_section", length = 400)
    public String kodeSection;

    @Column(name = "kode_segment", length = 400)
    public String kodeSegment;

    @Column(name = "kode_lateral", length = 400)
    public String kodeLateral;

    @Column(name = "no_cabang_section", length = 400)
    public String noCabangSection;

    @Column(name = "no_cabang_segment", length = 400)
    public String noCabangSegment;

    @Column(name = "kode_trafo", length = 400)
    public String kodeTrafo;

    @Column(name = "kode_gd", length = 400)
    public String kodeGd;

    @Column(name = "jenis_trafo", length = 6)
    public String jenisTrafo;

    @Column(name = "jenis_pemakaian", length = 50)
    public String jenisPemakaian;

    @Column(name = "coverage", length = 400)
    public String coverage;

    @Column(name = "jml_jurusan")
    public Long jmlJurusan;

    @Column(name = "merk", length = 200)
    public String merk;

    @Column(name = "no_seri", length = 400)
    public String noSeri;

    @Column(name = "thn_buat", length = 4)
    public String thnBuat;

    @Column(name = "thn_pasang", length = 4)
    public String thnPasang;

    @Column(name = "no_urut", length = 400)
    public String noUrut;

    @Column(name = "start_switch", length = 400)
    public String startSwitch;

    @Column(name = "finish_switch1", length = 400)
    public String finishSwitch1;

    @Column(name = "finish_switch2", length = 400)
    public String finishSwitch2;

    @Column(name = "finish_switch3", length = 400)
    public String finishSwitch3;

    @Column(name = "finish_switch4", length = 400)
    public String finishSwitch4;

    @Column(name = "type_parent")
    public Long typeParent;

    @Column(name = "kode_jaringan", length = 400)
    public String kodeJaringan;

    @Column(name = "kode_cabsection", length = 200)
    public String kodeCabSection;

    @Column(name = "kode_cabsegment", length = 200)
    public String kodeCabSegment;

    @Column(name = "kode_subsegment", length = 200)
    public String kodeSubSegment;

    @Column(name = "kode_subsubsegment", length = 200)
    public String kodeSubSubSegment;

    @Column(name = "kode_sublateral", length = 200)
    public String kodeSubLateral;

    @Column(name = "kode_subsublateral", length = 200)
    public String kodeSubSubLateral;

    @Column(name = "jml_trafo")
    public Long jmlTrafo;

    @Column(name = "fuse")
    public Long fuse;

    @Column(name = "kode_jurusan", length = 200)
    public String kodeJurusan;

    @Column(name = "aktif")
    public Long aktif;

    @Column(name = "subtypeasset")
    public Long subTypeAsset;

    @Column(name = "finish_switch5", length = 45)
    public String finishSwitch5;

    @Column(name = "finish_switch6", length = 45)
    public String finishSwitch6;

    @Column(name = "finish_switch7", length = 45)
    public String finishSwitch7;

    @Column(name = "finish_switch8", length = 45)
    public String finishSwitch8;

    @Column(name = "finish_switch9", length = 45)
    public String finishSwitch9;

    @Column(name = "finish_switch10", length = 45)
    public String finishSwitch10;

    @Column(name = "finish_switch11", length = 45)
    public String finishSwitch11;

    @Column(name = "finish_switch12", length = 45)
    public String finishSwitch12;

    @Column(name = "finish_switch13", length = 45)
    public String finishSwitch13;

    @Column(name = "finish_switch14", length = 45)
    public String finishSwitch14;

    @Column(name = "finish_switch15", length = 45)
    public String finishSwitch15;

    @Column(name = "finish_switch16", length = 45)
    public String finishSwitch16;

    @Column(name = "unit2", length = 5)
    public String unit2;

    @Column(name = "jml_plgn2")
    public Long jmlPlgn2;

    @Column(name = "express", length = 10)
    public String express;

    @Transient
    @Column(name = "rowid", nullable = false)
    public Long rowId;

    @Column(name = "geom_point", columnDefinition = "GEOMETRY(POINT,4326)")
    public String geomPoint;

    @Column(name = "id_up3")
    public Long idUp3;
}
