package org.sadigit.entity.transaksi;

import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

import org.sadigit.entity.referensi.Posko;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;

import java.time.LocalDate;

@Entity
@Setter
@Getter
@Table(name = "gangguan_alih_posko", schema = "apkt_transactional")
public class GangguanAlihPosko extends PanacheEntityBase{

    @Id
    @SequenceGenerator(name = "gangguan_alih_posko_seq", sequenceName = "apkt_transactional.gangguan_alih_posko_seq", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "gangguan_alih_posko_seq")
    @Column(name = "id")
    private Long id;

    @ManyToOne
    @JoinColumn(name = "id_gangguan", nullable = false)
    private Gangguan gangguan;

    @ManyToOne
    @JoinColumn(name = "id_posko_lama", nullable = false)
    private Posko poskoLama;

    @ManyToOne
    @JoinColumn(name = "id_posko_baru", nullable = false)
    private Posko poskoBaru;

    @Column(name = "waktu_alih_posko", nullable = false)
    private LocalDate waktu_alih_posko;

    @Column(name = "created_date")
    private LocalDate created_date;

    @Column(name = "created_by")
    private Long created_by;

    @Column(name = "updated_date")
    private LocalDate updated_date;

    @Column(name = "updated_by")
    private Long updated_by;

}