package org.sadigit.entity.transaksi;

import java.time.LocalDateTime;

import org.hibernate.annotations.Immutable;
import org.sadigit.entity.referensi.Cuaca;
import org.sadigit.entity.referensi.Dampak;
import org.sadigit.entity.referensi.Equipment;
import org.sadigit.entity.referensi.Fasilitas;
import org.sadigit.entity.referensi.GrupPenyebabGangguan;
import org.sadigit.entity.referensi.Kelompok;
import org.sadigit.entity.referensi.KelompokUtama;
import org.sadigit.entity.referensi.PenyebabGangguan;
import org.sadigit.entity.referensi.SubFasilitas;
import org.sadigit.entity.referensi.SubTipePermasalahan;
import org.sadigit.entity.referensi.TipePermasalahan;
import org.sadigit.entity.referensi.Ulp;

import io.quarkus.hibernate.orm.panache.PanacheEntity;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "gangguan_tm", schema = "apkt_transactional")
@Immutable
public class GangguanTm extends PanacheEntity {
    private Long id;

    @Column(name = "prioritas")
    private String prioritas;

    @ManyToOne
    @JoinColumn(name = "id_ulp")
    private Ulp idUlp;

    @Column(name = "perkiraan_area_padam")
    private String perkiraanAreaPadam;

    @Column(name = "estimasi_padam")
    private String estimasiPadam;

    @Column(name = "titik_gangguan")
    private String titikGangguan;

    @Column(name = "no_tiang")
    private String noTiang;

    @Column(name = "nama_asset")
    private String namaAsset;

    @Column(name = "status_akhir")
    private String statusAkhir;

    @Column(name = "jumlah_pelanggan")
    private Long jumlahPelanggan;

    @Column(name = "ampere")
    private Long ampere;

    @Column(name = "cuaca")
    private String cuaca;

    @Column(name = "no_gangguan_tm")
    private String noGangguanTm;

    @Column(name = "keterangan", length = 4000)
    private String keterangan;

    @Column(name = "created_date")
    private LocalDateTime createdDate;

    @Column(name = "created_by")
    private Long createdBy;

    @Column(name = "updated_date")
    private LocalDateTime updatedDate;

    @Column(name = "updated_by")
    private Long updatedBy;

    @ManyToOne
    @JoinColumn(name = "id_regu")
    private MasterRegu idRegu;

    @Column(name = "alasan")
    private String alasan;

    @Column(name = "id_jaringan")
    private Long idJaringan;

    @Column(name = "waktu_lapor")
    private LocalDateTime waktuLapor;

    @Column(name = "waktu_rencana")
    private LocalDateTime waktuRencana;

    @Column(name = "waktu_pengerjaan")
    private LocalDateTime waktuPengerjaan;

    @Column(name = "waktu_nyala_bertahap")
    private LocalDateTime waktuNyalaBertahap;

    @Column(name = "waktu_nyala")
    private LocalDateTime waktuNyala;

    @Column(name = "waktu_revisi")
    private LocalDateTime waktuRevisi;

    @Column(name = "waktu_disetujui")
    private LocalDateTime waktuDisetujui;

    @Column(name = "waktu_selesai")
    private LocalDateTime waktuSelesai;

    @Column(name = "tipe_jaringan")
    private String tipeJaringan;

    @ManyToOne
    @JoinColumn(name = "id_kelompok_utama")
    private KelompokUtama idKelompokUtama;

    @ManyToOne
    @JoinColumn(name = "id_kelompok")
    private Kelompok idKelompok;

    @ManyToOne
    @JoinColumn(name = "id_fasilitas")
    private Fasilitas idFasilitas;

    @ManyToOne
    @JoinColumn(name = "id_sub_fasilitas")
    private SubFasilitas idSubFasilitas;

    @ManyToOne
    @JoinColumn(name = "id_equipment")
    private Equipment idEquipment;

    @Column(name = "waktu_perjalanan")
    private LocalDateTime waktuPerjalanan;

    @ManyToOne
    @JoinColumn(name = "id_tipe_permasalahan")
    private TipePermasalahan idTipePermasalahan;

    @ManyToOne
    @JoinColumn(name = "id_sub_tipe_permasalahan")
    private SubTipePermasalahan idSubTipePermasalahan;

    @ManyToOne
    @JoinColumn(name = "id_penyebab")
    private PenyebabGangguan idPenyebab;

    @ManyToOne
    @JoinColumn(name = "id_grup_penyebab")
    private GrupPenyebabGangguan idGrupPenyebab;

    @ManyToOne
    @JoinColumn(name = "id_dampak")
    private Dampak idDampak;

    @ManyToOne
    @JoinColumn(name = "id_cuaca")
    private Cuaca idCuaca;

}
