package org.sadigit.entity.transaksi;

import java.time.LocalDateTime;

import io.quarkus.hibernate.orm.panache.PanacheEntityBase;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Entity
@Setter
@Getter
@Table(name = "keluhan_lapor_ulang", schema = "apkt_transactional")
@NoArgsConstructor
@AllArgsConstructor
public class KeluhanLaporUlang extends PanacheEntityBase{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Long id;

    @ManyToOne
    @JoinColumn(name = "id_keluhan", nullable = false)
    private Keluhan keluhan;

    @Column(name = "no_laporan_referensi", nullable = false)
    private String no_laporan_referensi;

    @Column(name = "no_laporan_baru", nullable = false)
    private String no_laporan_baru;

    @Column(name = "laporan_ke", nullable = false)
    private Long laporan_ke;

    @Column(name = "created_date")
    private LocalDateTime created_date;

    @Column(name = "created_by")
    private Long created_by;

    @Column(name = "updated_date")
    private LocalDateTime updated_date;

    @Column(name = "updated_by")
    private Long updated_by;

    

    // Getters and Setters
}
