package org.sadigit.model.request;

import java.util.Map;

import org.sadigit.control.exception.CustomException;
import org.sadigit.model.response.base.ResponseModel;

import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.QueryParam;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Builder
@Data
@NoArgsConstructor
@AllArgsConstructor
public class CreateGangguanRequest {

    @QueryParam("in_idpel")
    @NotNull
    String in_idpel;

    @QueryParam("in_nama")
    @NotNull
    String in_nama;

    @NotNull
    @QueryParam("in_alamat")
    String in_alamat;

    @NotNull
    @QueryParam("in_hp")
    String in_hp;

    @NotNull
    @QueryParam("in_unitup")
    String in_unitup;

    @NotNull
    @QueryParam("in_long")
    String in_long;

    @NotNull
    @QueryParam("in_lat")
    String in_lat;

    @NotNull
    @QueryParam("in_tipe_keluhan")
    String in_tipe_keluhan;

    @NotNull
    @QueryParam("in_keterangan")
    String in_keterangan;

    @NotNull
    @QueryParam("in_prov")
    String in_prov;

    @NotNull
    @QueryParam("in_kab")
    String in_kab;

    @NotNull
    @QueryParam("in_kec")
    String in_kec;

    @NotNull
    @QueryParam("in_kel")
    String in_kel;

    @QueryParam("in_flag_padam_tm")
    String in_flag_padam_tm;

    @QueryParam("in_laporan_ref")
    String in_laporan_ref;

    public void checkParameter() {
        if (this.getIn_kel() == null || this.getIn_kel().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "nama kelurahan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_kec() == null || this.getIn_kec().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Nama kecamatan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_kab() == null || this.getIn_kab().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Nama kabupaten tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_prov() == null || this.getIn_prov().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Nama provinsi tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_nama() == null || this.getIn_nama().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Nama tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_alamat() == null || this.getIn_alamat().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Alamat tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_hp() == null || this.getIn_hp().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "No telp tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_unitup() == null || this.getIn_unitup().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Unitup tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_long() == null || this.getIn_long().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Longitude tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_lat() == null || this.getIn_lat().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Latitude tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_tipe_keluhan() == null || this.getIn_tipe_keluhan().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Tipe keluhan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }

        if (this.getIn_keterangan() == null || this.getIn_keterangan().isEmpty()) {
            var error = ResponseModel.builder()
                    .data(Map.of("msg", "Keterangan tidak boleh kosong"))
                    .build();
            throw new CustomException(null, error);
        }
    }
}
