package org.sadigit.model.response;

import java.time.LocalDateTime;
import org.sadigit.entity.transaksi.Gangguan;
import jakarta.json.bind.annotation.JsonbDateFormat;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
public class DetailPengaduanResponse {
    String summary;
    Long customernumber;
    Double latitude;
    Double longitude;
    String reportnumber;
    String nohp_petugas;
    String token_ctt;
    String penyebab;
    String tindakan;
    String reporteraddress;
    String reportername;
    String status_marking;
    String description;
    String nolaporulangawal;

    @JsonbDateFormat("yyyy/MM/dd HH:mm")
    LocalDateTime createdate;

    public static DetailPengaduanResponse fromGangguanEntity(Gangguan gangguan) {
        return DetailPengaduanResponse.builder()
                .summary(gangguan.getKeterangan())
                .customernumber(gangguan.getId_pelanggan_no_meter())
                .latitude(gangguan.getLokasi().getCoordinate().x)
                .longitude(gangguan.getLokasi().getCoordinate().y)
                .reportnumber(gangguan.getNo_laporan())
                .nohp_petugas(gangguan.getRegu() == null ? null : gangguan.getRegu().getTelepon())
                .token_ctt(gangguan.getCtt())
                .penyebab(gangguan.getPenyebab() == null ? null : gangguan.getPenyebab().getNama())
                .tindakan(gangguan.getTindakan() == null ? null : gangguan.getTindakan().getNama())
                .reporteraddress(gangguan.getAlamat_pelapor())
                .reportername(gangguan.getNama_pelapor())
                .status_marking(gangguan.getStatus_akhir())
                .description(null)
                .nolaporulangawal(null)
                .createdate(gangguan.getCreated_date())
                .build();
    }

}
