package org.sadigit.model.response;

import java.time.LocalDateTime;

import org.sadigit.entity.saidisaifi.masterJaringan.MasterGarduIndukTransaksi;

import jakarta.json.bind.annotation.JsonbDateFormat;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
public class GarduRencanaV2Response {
    String coverage;
    String kode_gardu;
    String no_laporan;
    String keterangan;
    String unitap;
    String unitupi;
    
    @JsonbDateFormat("yyyy/MM/dd HH:mm")
    LocalDateTime tglcatat;

    String latitude;
    String unitup;
    
    @JsonbDateFormat("yyyy/MM/dd HH:mm")
    LocalDateTime tgl_awal;

    String nama_gardu;
    String longitude;
    String status;

    public static GarduRencanaV2Response fromMasterGarduIndukTransaksi (MasterGarduIndukTransaksi masterGarduIndukTransaksi) {
        Double longitude = masterGarduIndukTransaksi.getGarduInduk().getLokasi().getCoordinate().x;
        Double latitude = masterGarduIndukTransaksi.getGarduInduk().getLokasi().getCoordinate().y;
        
        return GarduRencanaV2Response.builder()
            .coverage(null)
            .kode_gardu(masterGarduIndukTransaksi.getGarduInduk().getKode())
            .no_laporan(masterGarduIndukTransaksi.getNo_laporan())
            .keterangan(masterGarduIndukTransaksi.getKeterangan())
            .unitap(null)
            .unitupi(null)
            .tglcatat(masterGarduIndukTransaksi.getWaktu_catat())
            .latitude(latitude.toString())
            .unitup(null)
            .tgl_awal(masterGarduIndukTransaksi.getWaktu_catat())
            .nama_gardu(masterGarduIndukTransaksi.getGarduInduk().getNama())
            .longitude(longitude.toString())
            .status(masterGarduIndukTransaksi.getStatus())
            .build();
    }
}
