package org.sadigit.model.response;

import org.sadigit.entity.referensi.Kabupaten;
import org.sadigit.entity.referensi.Kecamatan;
import org.sadigit.entity.referensi.MasterKelurahan;
import org.sadigit.entity.referensi.Provinsi;

import lombok.Builder;
import lombok.Getter;
import lombok.AllArgsConstructor;

@Builder
@Getter
@AllArgsConstructor
public class GetDataKeteranganLokasi {
    private Long id;
    private String keterangan;

    public static GetDataKeteranganLokasi fromMasterKelurahan(MasterKelurahan masterKelurahan) {
        return GetDataKeteranganLokasi.builder()
            .id(masterKelurahan.getId_kelurahan())
            .keterangan(masterKelurahan.getNama_kelurahan())
            .build();
    }

    public static GetDataKeteranganLokasi fromMasterKecamatan(Kecamatan kecamatan) {
        return GetDataKeteranganLokasi.builder()
            .id(kecamatan.getId())
            .keterangan(kecamatan.getNama())
            .build();
    }

    public static GetDataKeteranganLokasi fromMasterKabupaten(Kabupaten kabupaten) {
        return GetDataKeteranganLokasi.builder()
            .id(kabupaten.getId())
            .keterangan(kabupaten.getNama())
            .build();
    }

    public static GetDataKeteranganLokasi fromMasterProvinsi(Provinsi provinsi) {
        return GetDataKeteranganLokasi.builder()
            .id(provinsi.getId())
            .keterangan(provinsi.getNama_provinsi())
            .build();
    }
}
