package org.sadigit.model.response;

import org.sadigit.entity.saidisaifi.masterJaringan.MasterGarduDistribusi;
import lombok.Builder;
import lombok.Data;

@Data
@Builder
public class GetDataKode4Response {
    String no_tiang;
    String status_nyala;
    String kode_asset;
    String nama;
    Double latitude;
    String alamat;
    Double longitude;

    public static GetDataKode4Response fromGarduIndukDistribusi(MasterGarduDistribusi garduDistribusi) {
        return GetDataKode4Response.builder()
            .no_tiang(garduDistribusi.getNoTiang())
            .status_nyala(garduDistribusi.getStatus())
            .kode_asset(garduDistribusi.getKode())
            .nama(garduDistribusi.getNama())
            .latitude(garduDistribusi.getPoint().getCoordinate().y)
            .alamat(garduDistribusi.getAlamat())
            .longitude(garduDistribusi.getPoint().getCoordinate().x)
            .build();
    }
}
