package org.sadigit.model.response;

import java.time.LocalDateTime;
import jakarta.json.bind.annotation.JsonbDateFormat;
import jakarta.persistence.Tuple;
import lombok.Builder;
import lombok.Getter;

@Getter
@Builder
public class GetHistoByIdpelResponse {
    String summary;
    Long customernumber;
    String reportnumber;
    String reporteraddress;

    @JsonbDateFormat("yyyy/MM/dd hh:mm")
    LocalDateTime createdate;
    
    String reportername;
    String nama_regu;

    public static GetHistoByIdpelResponse fromTuple(Tuple tuple) {
        return GetHistoByIdpelResponse.builder()
                .summary(tuple.get("keterangan", String.class))
                .customernumber(tuple.get("idpel", Long.class))
                .reportnumber(tuple.get("noLaporan", String.class))
                .reporteraddress(tuple.get("alamatPelapor", String.class))
                .createdate(tuple.get("createdDate", LocalDateTime.class))
                .reportername(tuple.get("namaPelapor", String.class))
                .nama_regu(tuple.get("namaRegu", String.class))
                .build();
    }
}
