package org.sadigit.model.response;

import java.time.LocalDateTime;

import org.sadigit.entity.transaksi.Gangguan;
import org.sadigit.entity.transaksi.Keluhan;

import jakarta.json.bind.annotation.JsonbDateFormat;
import lombok.Builder;
import lombok.Getter;

@Getter
@Builder
public class GetHistoriGangguanByIdResponse {
    private String summary;
    private Long customernumber;
    private String reportnumber;
    private String reporteraddress;
    private String reportername;
    
    @JsonbDateFormat("YYYY/mm/dd hh:mm")
    private LocalDateTime createdate;
    
    private String nama_regu;

    public static GetHistoriGangguanByIdResponse fromGangguan(Gangguan gangguan) {
        return GetHistoriGangguanByIdResponse.builder()
            .summary(gangguan.getKeterangan())
            .customernumber(gangguan.getId_pelanggan_no_meter())
            .reportnumber(gangguan.getNo_laporan())
            .reporteraddress(gangguan.getAlamat_pelapor())
            .createdate(gangguan.getCreated_date())
            .reportername(gangguan.getNama_pelapor())
            .nama_regu(gangguan.getRegu() == null ? null : gangguan.getRegu().getNama())
            .build();
    }

    public static GetHistoriGangguanByIdResponse fromKeluhan(Keluhan keluhan) {
        return GetHistoriGangguanByIdResponse.builder()
            .summary(keluhan.getKeterangan())
            .customernumber(keluhan.getId_pelanggan_no_meter())
            .reportnumber(keluhan.getNo_laporan())
            .reporteraddress(keluhan.getAlamat_pelapor())
            .createdate(keluhan.getCreated_date())
            .reportername(keluhan.getNama_pelapor())
            .nama_regu(keluhan.getRegu() == null ? null : keluhan.getRegu().getNama())
            .build();
    }
}
