package org.sadigit.repository.entity.saidisaifi.masterjaringan;

import java.util.List;

import org.sadigit.entity.referensi.SystemParameter;
import org.sadigit.entity.saidisaifi.masterJaringan.MasterGarduDistribusi;
import io.quarkus.hibernate.orm.panache.PanacheRepository;
import jakarta.enterprise.context.ApplicationScoped;

@ApplicationScoped
public class MasterGarduDistribusiRepository implements PanacheRepository<MasterGarduDistribusi>{

    @SuppressWarnings("unchecked")
    public List<MasterGarduDistribusi> findByGeomRadius(Double longitude, Double latitude) {       
        String nativeQuery = """
                select *
                from master_gardu_distribusi
                where ST_DWithin(point\\:\\:geography, ST_SetSRID(POINT(:longitude :latitude)),4326)\\::geography, :radius)
                where 
                """;
        
        SystemParameter systemParameter = SystemParameter.find("id", 78).firstResult();
        return this.getEntityManager().createNativeQuery(nativeQuery, MasterGarduDistribusi.class)
            .setParameter("longitude", longitude)
            .setParameter("latitude", latitude)
            .setParameter("radius", systemParameter.getValue())
            .getResultList();
    }
}
